Codeforces Round 536 (Div. 2)
D
Lunar New Year and a Wander
Codeforces
1500
原题
← CE →
翻译中…

Lunar New Year is approaching, and Bob decides to take a wander in a nearby park.

翻译中…

The park can be represented as a connected graph with $n$ nodes and $m$ bidirectional edges. Initially Bob is at the node $1$ and he records $1$ on his notebook. He can wander from one node to another through those bidirectional edges. Whenever he visits a node not recorded on his notebook, he records it. After he visits all nodes at least once, he stops wandering, thus finally a permutation of nodes $a_1, a_2, \ldots, a_n$ is recorded.

翻译中…

Wandering is a boring thing, but solving problems is fascinating. Bob wants to know the lexicographically smallest sequence of nodes he can record while wandering. Bob thinks this problem is trivial, and he wants you to solve it.

翻译中…

A sequence $x$ is lexicographically smaller than a sequence $y$ if and only if one of the following holds:

翻译中…
  • $x$ is a prefix of $y$, but $x \ne y$ (this is impossible in this problem as all considered sequences have the same length);
  • in the first position where $x$ and $y$ differ, the sequence $x$ has a smaller element than the corresponding element in $y$.
翻译中…

Input

翻译中…

The first line contains two positive integers $n$ and $m$ ($1 \leq n, m \leq 10^5$), denoting the number of nodes and edges, respectively.

翻译中…

The following $m$ lines describe the bidirectional edges in the graph. The $i$-th of these lines contains two integers $u_i$ and $v_i$ ($1 \leq u_i, v_i \leq n$), representing the nodes the $i$-th edge connects.

翻译中…

Note that the graph can have multiple edges connecting the same two nodes and self-loops. It is guaranteed that the graph is connected.

翻译中…

Output

翻译中…

Output a line containing the lexicographically smallest sequence $a_1, a_2, \ldots, a_n$ Bob can record.

翻译中…

Note

翻译中…

In the first sample, Bob's optimal wandering path could be $1 \rightarrow 2 \rightarrow 1 \rightarrow 3$. Therefore, Bob will obtain the sequence $\{1, 2, 3\}$, which is the lexicographically smallest one.

翻译中…

In the second sample, Bob's optimal wandering path could be $1 \rightarrow 4 \rightarrow 3 \rightarrow 2 \rightarrow 3 \rightarrow 4 \rightarrow 1 \rightarrow 5$. Therefore, Bob will obtain the sequence $\{1, 4, 3, 2, 5\}$, which is the lexicographically smallest one.

翻译中…

样例

Input #1
3 2
1 2
1 3
Output #1
1 2 3
InputCopy OutputCopy
Input #2
5 5
1 4
3 4
5 4
3 2
1 5
Output #2
1 4 3 2 5
InputCopy OutputCopy
Input #3
10 10
1 4
6 8
2 5
3 7
9 4
5 6
3 4
8 10
8 9
1 10
Output #3
1 4 3 7 9 8 6 5 2 10
InputCopy OutputCopy
题目信息
题号
1106D
时间限制
3 s
内存限制
256 MB
标签
数据结构
DFS 及类似
图论
贪心
最短路

题面与样例版权归 Codeforces 及出题人所有;中文翻译由 AI 生成(CI 管线),如有出入请以原文为准。